// 
// Author:
//       smdn <smdn@mail.invisiblefulmoon.net>
// 
// Copyright (c) 2009 smdn
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Globalization;
using System.Resources;

namespace Smdn.Windows.Forms.ThbgmPlayer {
  public static class Texts {
    private static ResourceManager resourceManager = new ResourceManager("Smdn.Windows.Forms.ThbgmPlayer.Texts", typeof(Texts).Assembly);
    private static CultureInfo resourceCulture = null;

    public static System.Globalization.CultureInfo Culture {
      get { return resourceCulture; }
      set { resourceCulture = value; }
    }

    public static string GetText(FadingCurveType type)
    {
      switch (type) {
        case FadingCurveType.Linear: return resourceManager.GetString("FadingCurveType_Linear", resourceCulture);
        case FadingCurveType.Exponential: return resourceManager.GetString("FadingCurveType_Exponential", resourceCulture);
        case FadingCurveType.Logarithmic: return resourceManager.GetString("FadingCurveType_Logarithmic", resourceCulture);
        case FadingCurveType.Trigonometrical: return resourceManager.GetString("FadingCurveType_Trigonometrical", resourceCulture);
        case FadingCurveType.None: return resourceManager.GetString("FadingCurveType_None", resourceCulture);
        default: return type.ToString();
      }
    }

    public static string GetText(EffectLengthBasis basis)
    {
      switch (basis) {
        case EffectLengthBasis.FadingStart: return resourceManager.GetString("EffectLengthBasis_FadingStart", resourceCulture);
        case EffectLengthBasis.TotalLength: return resourceManager.GetString("EffectLengthBasis_TotalLength", resourceCulture);
        case EffectLengthBasis.TimesToRepeat: return resourceManager.GetString("EffectLengthBasis_TimesToRepeat", resourceCulture);
        default: return basis.ToString();
      }
    }

    public static string GetText(string name)
    {
      return resourceManager.GetString(name, resourceCulture);
    }
  }
}