using System;
using System.Threading;
using System.Windows.Forms;

using Smdn.Collections;

namespace Smdn.Applications.ThbgmExtractor {
  public class ExtractionContext {
    public ExtractionConfig Config {
      get; private set;
    }

    public ExtractionProgress Progress {
      get; private set;
    }

    public bool IsAbortRequested {
      get { return abortEvent.WaitOne(0, false); }
    }

    public ManualResetEvent AbortEvent {
      get { return abortEvent; }
    }

    internal Thread ExtractorThread {
      get; set;
    }

    public ExtractionStage Stage {
      get; internal set;
    }

    public ExtractionContext(ExtractionConfig config)
    {
      this.Config = config;
      this.Progress = new ExtractionProgress(config.Tracks.Count());
      this.Stage = ExtractionStage.NotStarted;
    }

    private ManualResetEvent abortEvent = new ManualResetEvent(false);
  }
}
